<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.20</title>
    <link rel="stylesheet" href="30.20.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="container">
            <div class="row Sign-up">
                <div class="col-md-6">
                    <h2 class="text-success">Create a free account</h2>
                    <form class="form" id="SignIn-form">
                        <div class="form-group">
                            <label for="exampleInputName1">Name</label>
                            <input type="text" class="form-control" id="exampleInputName1" placeholder="Your name">
                        </div>
                        <div class="form-group">
                            <label for="exampleInputEmail1">Email address</label>
                            <input type="email" class="form-control" id="exampleInputEmail1"
                                aria-describedby="emailHelp" placeholder="Your email address">
                        </div>
                        <div class="form-group">
                            <label for="exampleInputPassword1">Password</label>
                            <input type="password" class="form-control" id="exampleInputPassword1"
                                placeholder="Password">
                        </div>
                        <div class="form-group">
                            <label for="exampleInputConfirmPassword1">Confirm Password</label>
                            <input type="password" class="form-control" id="exampleInputConfirmPassword1"
                                placeholder="Confirm Password">
                        </div>
                        <button type="submit" class="btn btn-success form-control">Sign up</button>
                        <div class="agree-signin">
                            <p class="text-center" style="font-size: 10px; margin-top: 20px; ">By signing up you agree
                                to our <a class="text-success">Terms of Service</a> and <a class="text-success">Privacy
                                    Policy</a></p>
                        </div>
                        <div class="Bottom-Title">
                            <p class="text-center" style="margin-top: 40px;">Already have an account?<a
                                    class="text-success">Login</a></p>
                        </div>
                    </form>
                </div>
                <div class="col-md-6 image">
                    <img src="undraw_invest_88iw.png" class="img-1">
                    <img src="patterns-geometricos (13).png" class="img-2">
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    var gSignUpFormElement = document.getElementById("SignIn-form");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSignUpFormElement.addEventListener("submit", function (paramEvent) {
        //Loại bỏ mặc định cấu hình form
        paramEvent.preventDefault();
        SignUp();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm gọi API
    function SignUp() {
        // khai báo đối tượng
        var vPersonObj = {
            name: "",
            email: "",
            password: "",
            confirmpassword: ""
        };
        //B1: thu thập dữ liệu
        thuThapDuLieu(vPersonObj);
        //B2: kiểm tra dữ liệu
        var vDuLieuHopLe = validateDataSignUp(vPersonObj);
        if (vDuLieuHopLe) {
            //B3: gọi API
            callAPISignUp(vPersonObj);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu
    function thuThapDuLieu(paramPersonObj) {
        var vNameInput = document.getElementById("exampleInputName1");
        var vEmailInput = document.getElementById("exampleInputEmail1");
        var vPasswordInput = document.getElementById("exampleInputPassword1");
        var vConfirmPasswordinput = document.getElementById("exampleInputConfirmPassword1");

        paramPersonObj.name = vNameInput.value.trim();
        paramPersonObj.email = vEmailInput.value.trim();
        paramPersonObj.password = vPasswordInput.value.trim();
        paramPersonObj.confirmpassword = vConfirmPasswordinput.value.trim();
    }
    //Hàm kiểm tra dữ liệu input
    function validateDataSignUp(paramPersonObj) {
        if (paramPersonObj.name === "") {
            alert("Name không được để trống");
            return false;
        }
        if (!paramPersonObj.email.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }
        if (paramPersonObj.password.length < 8) {
            alert("Password phải có từ 8 kí tự trở lên");
            return false;
        }
        if (paramPersonObj.confirmpassword != paramPersonObj.password) {
            alert("Vui lòng nhập đúng password");
            return false;
        }
        return true;
    }
    //Gọi API
    function callAPISignUp(paramPersonObj) {
        var vData = JSON.stringify(paramPersonObj)
        //chuẩn bị gọi API
        var vXmlHttpSignUp = new XMLHttpRequest();
        vXmlHttpSignUp.open("POST", gBASE_URL, true);
        vXmlHttpSignUp.send(vData);
        vXmlHttpSignUp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    var vsignupResponseText = vXmlHttpSignUp.responseText
                    var vSignUpInfo = JSON.parse(vsignupResponseText);
                    console.log(vSignUpInfo)
                    //B4: Xử lý hiển thị
                    if (vSignUpInfo.length != "") {
                        alert("Đăng nhập thành công");
                    }
                    else {
                        alert("Dăng nhập không thành công");
                    }
                }
            }
    }

</script>

</html>